;.............................................
;stromcek 2011
;..............................................



	$MODxx51
	ORG	0	

RYCH	BIT	P3.0
PROG	BIT	P3.1
DISP	BIT	P3.5
LED	BIT	P3.7
PORT	EQU	P1
;........................................
RESET:	MOV	R0,#0		;nuluj registry pre cas
	MOV	R1,#0		;nuluj registry pre cas
	MOV	R4,#0		;po resete program 0
	MOV	R6,#4		;pomocnz pre zmenu casu
	MOV	R5,#7		;po resete rychlost 7
				
;........................................
START:	JMP	PROG0		;skoc na prog0

RYCH1:	SETB	LED		;led vypnute
	CLR	DISP		;zapni displej
	CJNE	R5,#1,RYCH2	;ak R5 sa nerovna 1, skoc na rych2, ak sa rovna pokracuj v programe
	MOV	A,#11011110B	;do a napis cislo 1
	MOV	PORT,A		;posli cislo 1 na port, teda sa zobrazi na displeji
	MOV	R6,#14		;pomocnz pre zmenu casu, cim vcsie cislo tym pomalsie
	CALL	ZISTITL		;skuska ci bolo stlacene tlacidlo prog alebo rych
	JMP	VONPROG1	;ak nebolo skoc na vonprog1

RYCH2:	CJNE	R5,#2,RYCH3
	MOV	A,#00110100B
	MOV	PORT,A
	MOV	R6,#12
	CALL	ZISTITL
	JMP	VONPROG

RYCH3:	CJNE	R5,#3,RYCH4
	MOV	A,#10010100B
	MOV	PORT,A
	MOV	R6,#10
	CALL	ZISTITL
	JMP	VONPROG

RYCH4:	CJNE	R5,#4,RYCH5
	MOV	A,#11010010B
	MOV	PORT,A
	MOV	R6,#9
	CALL	ZISTITL
	JMP	VONPROG

RYCH5:	CJNE	R5,#5,RYCH6
	MOV	A,#10010001B
	MOV	PORT,A
	MOV	R6,#7
	CALL	ZISTITL
	JMP	VONPROG

RYCH6:	CJNE	R5,#6,RYCH7
	MOV	A,#00010001B
	MOV	PORT,A
	MOV	R6,#5
	CALL	ZISTITL
	JMP	VONPROG

RYCH7:	CJNE	R5,#7,RYCH8
	MOV	A,#11011100B
	MOV	PORT,A
	MOV	R6,#4
	CALL	ZISTITL
	JMP	VONPROG

RYCH8:	CJNE	R5,#8,RYCH9
	MOV	A,#00010000B
	MOV	PORT,A
	MOV	R6,#2
	CALL	ZISTITL
	JMP	VONPROG

RYCH9:	CJNE	R5,#9,RYCH1
	MOV	A,#10010000B
	MOV	PORT,A
	MOV	R6,#1
	CALL	ZISTITL
	JMP	VONPROG

VONPROG:CJNE	R4,#0,VON1		;porovnavanie R4 pre vyber efektu
	JMP	EFEKT0
VON1:	CJNE	R4,#1,VON2
	JMP	EFEKT1
VON2:	CJNE	R4,#2,VON3
	JMP	EFEKT2
VON3:	CJNE	R4,#3,VON4
	JMP	EFEKT3
VON4:	CJNE	R4,#4,VON5
	JMP	EFEKT4
VON5:	CJNE	R4,#5,VON6
	JMP	EFEKT5
VON6:	CJNE	R4,#6,VON7
	JMP	EFEKT6
VON7:	CJNE	R4,#7,VON8
	JMP	EFEKT7
VON8:	CJNE	R4,#8,VON9
	JMP	EFEKT8
VON9:	CJNE	R4,#9,VONPROG
	JMP	EFEKT9

PROG0:	SETB	LED			;vypni led
	CLR	DISP			;zapni displej
	CJNE	R4,#0,PROG1		;ak R4 sa nerovna 0 skoc na prog1, ak sa rovna pokracuj v programe
	MOV	A,#00001000B		;do A zapis 0
	MOV	PORT,A			;posli na port, teda na displej
	CALL	ZISTITL			;skuska ci bolo stlacene tlacidlo prog alebo rych
	JMP	EFEKT0			;ak nie skoc na efekt0

PROG1:	CJNE	R4,#1,PROG2
	MOV	A,#11001110B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT1

PROG2:	CJNE	R4,#2,PROG3
	MOV	A,#00100100B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT2

PROG3:	CJNE	R4,#3,PROG4
	MOV	A,#10000100B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT3

PROG4:	CJNE	R4,#4,PROG5
	MOV	A,#11000010B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT4

PROG5:	CJNE	R4,#5,PROG6
	MOV	A,#10000001B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT5

PROG6:	CJNE	R4,#6,PROG7
	MOV	A,#00000001B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT6

PROG7:	CJNE	R4,#7,PROG8
	MOV	A,#11001100B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT7

PROG8:	CJNE	R4,#8,PROG9
	MOV	A,#00000000B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT8

PROG9:	CJNE	R4,#9,PROG0
	MOV	A,#10000000B
	MOV	PORT,A
	CALL	ZISTITL
	JMP	EFEKT9


EFEKT0:	CALL	BLIK			;skoc na podprogram blik
	MOV	R3,#1			;do R3 zapis, ak sa R3 rovna 1 programz sa budu menit od 1 az po 9.Ak bude 0 pojde iba jeden program 
	JMP	ZNOVA1			;skoc na znova1

EFEKT1:	CALL	BLIK			;skoc na podprogram blik
	MOV	R3,#0			;do r3 zapis 0, teda bude beyat len program 1 dookola
ZNOVA1:	MOV	R7,#0			;nuluj pocitanie cyklov
SMYCKA1:MOV	DPTR,#TAB1		;do dptr nahraj TAB1
	MOV	A,R7			;z R7 do A
	MOVC	A,@A+DPTR		;vyber  udaj z tabulky
	MOV	PORT,A			;posli na port
	CALL	CAS			;skoc na cas
	INC	R7			;zvys R7
	CJNE	R7,#32,SMYCKA1		;ak je R7 nerovne 32 skoc na smycka1, ak je rovne 32, pokracuj v programe	
	CJNE	R3,#0,ZNOVA2		;ak R3 sa nerovna 0 skoc na znova 2. 
	JMP	ZNOVA1			;ak r3 sa rovna nule skoc na znova 1

EFEKT2:	CALL	BLIK			;a tak dalej
	MOV	R3,#0
ZNOVA2:	MOV	R7,#0
SMYCKA2:MOV	DPTR,#TAB2	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#34,SMYCKA2
	CJNE	R3,#0,ZNOVA3
	JMP	ZNOVA2

EFEKT3:	CALL	BLIK
	MOV	R3,#0
ZNOVA3:	MOV	R7,#0
SMYCKA3:MOV	DPTR,#TAB3	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#8,SMYCKA3
	CJNE	R3,#0,ZNOVA4
	JMP	ZNOVA3

EFEKT4:	CALL	BLIK
	MOV	R3,#0
ZNOVA4:	MOV	R7,#0
SMYCKA4:MOV	DPTR,#TAB4	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#32,SMYCKA4
	CJNE	R3,#0,ZNOVA5
	JMP	ZNOVA4

EFEKT5:	CALL	BLIK
	MOV	R3,#0
ZNOVA5:	MOV	R7,#0
SMYCKA5:MOV	DPTR,#TAB5	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#32,SMYCKA5
	CJNE	R3,#0,ZNOVA6
	JMP	ZNOVA5

EFEKT6:	CALL	BLIK
	MOV	R3,#0
ZNOVA6:	MOV	R7,#0
SMYCKA6:MOV	DPTR,#TAB6	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#60,SMYCKA6
	CJNE	R3,#0,ZNOVA7
	JMP	ZNOVA6

EFEKT7:	CALL	BLIK
	MOV	R3,#0
ZNOVA7:	MOV	R7,#0
SMYCKA7:MOV	DPTR,#TAB7	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#20,SMYCKA7
	CJNE	R3,#0,ZNOVA8
	JMP	ZNOVA7

EFEKT8:	CALL	BLIK
	MOV	R3,#0
ZNOVA8:	MOV	R7,#0
SMYCKA8:MOV	DPTR,#TAB8	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#8,SMYCKA8
	CJNE	R3,#0,ZNOVA9
	JMP	ZNOVA8

EFEKT9:	CALL	BLIK
	MOV	R3,#0
ZNOVA9:	MOV	R7,#0
SMYCKA9:MOV	DPTR,#TAB9	
	MOV	A,R7
	MOVC	A,@A+DPTR
	MOV	PORT,A
	CALL	CAS
	INC	R7
	CJNE	R7,#16,SMYCKA9
	CJNE	R3,#0,ZN1
	JMP	ZNOVA9
ZN1:	JMP	ZNOVA1


;.................................................
ZISTITL:JNB	PROG,ZMENAPROG
	JNB	RYCH,ZMENARYCH
	RET
;....................................
ZMENAPROG:CALL	CASTL
	INC	R4
	CJNE	R4,#10,VONPROG1
	MOV	R4,#0
VONPROG1:JMP	PROG0

ZMENARYCH:CALL	CASTL
	INC	R5
	CJNE	R5,#10,VONRYCH
	MOV	R5,#1
VONRYCH:JMP	RYCH1
	
CASTL:	MOV	R2,#5
SKOC:	DJNZ	R0,$
	DJNZ	R1,SKOC
	DJNZ	R2,SKOC
	RET

;............................................
CAS:	MOV	B,R6
	MOV	R2,B
SKOC0:	DJNZ	R0,$
	CALL	ZISTITL
	DJNZ	R1,SKOC0
	DJNZ	R2,SKOC0
	RET
;..........................................
BLIK:	SETB	LED
	CLR	DISP
CAS1:	MOV	R2,#18
SKOC1:	DJNZ	R0,$
	CALL	ZISTITL
	DJNZ	R1,SKOC1
	DJNZ	R2,SKOC1
	MOV	R7,#0
SMYCKA:	MOV	PORT,A
	CALL	CASBLIK
	PUSH	ACC
	MOV	A,#0FFH
	MOV	PORT,A
	CALL	CASBLIK
	POP	ACC
	INC	R7
	CJNE	R7,#9,SMYCKA
	SETB	DISP
	CLR	LED
	RET
	

CASBLIK:MOV	R2,#1
BLIK1:	DJNZ	R0,$
	DJNZ	R1,BLIK1
	DJNZ	R2,BLIK1
	RET
;...................................

TAB1:	DB 00011111B
	DB 00000111B	
	DB 00000001B
	DB 00000000B
	DB 00000001B
	DB 00000111B
	DB 00011111B
	DB 11111111B
	DB 00011111B
	DB 00000111B	
	DB 00000001B
	DB 00000000B
	DB 00000001B
	DB 00000111B
	DB 00011111B
	DB 11111111B


	DB 10111101B
	DB 10011001B	
	DB 10000001B
	DB 00000000B
	DB 10000001B
	DB 10011001B
	DB 10111101B
	DB 11111111B
	DB 10111101B
	DB 10011001B	
	DB 10000001B
	DB 00000000B
	DB 10000001B
	DB 10011001B
	DB 10111101B
	DB 11111111B

TAB2:	DB 01111111B	
	DB 00111111B
	DB 00011111B
	DB 00001111B
	DB 00000111B
	DB 00000011B	
	DB 00000001B
	DB 00000000B
	DB 00000001B
	DB 00000011B
	DB 00000111B
	DB 00001111B
	DB 00011111B
	DB 00111111B
	DB 01111111B
	DB 11111111B

	DB 00000000B
	DB 10000000B	
	DB 11000000B
	DB 11100000B
	DB 11110000B
	DB 11111000B
	DB 11111100B	
	DB 11111110B
	DB 11111111B
	DB 11111110B
	DB 11111100B
	DB 11111000B
	DB 11110000B
	DB 11100000B
	DB 11000000B
	DB 10000000B
	DB 00000000B
	DB 11111111B
	

TAB3:	DB 11111000B	
	DB 01100111B
	DB 10011111B
	DB 11111111B
	DB 11111000B	
	DB 01100111B
	DB 10011111B
	DB 11111111B

TAB4:	DB 00001000B
	DB 01000000B
	DB 00000010B
	DB 10000000B
	DB 00010000B
	DB 00000001B
	DB 00000100B
	DB 00100000B
	DB 01001000B
	DB 00000010B
	DB 00010000B
	DB 00000100B
	DB 10000000B
	DB 00000001B
	DB 00100000B
	DB 00000010B
	DB 00010000B
	DB 00000100B
	DB 10000000B
	DB 01000000B
	DB 00001000B
	DB 00000001B
	DB 00010000B
	DB 00000100B
	DB 01000000B
	DB 00000010B
	DB 00100000B
	DB 10000000B
	DB 00001000B
	DB 00000001B
	DB 01000000B
	DB 00000100B

TAB5:	DB 11101111B
	DB 01111111B
	DB 11111101B
	DB 11101111B
	DB 01111111B
	DB 11111110B
	DB 11110111B
	DB 11011111B
	DB 11111011B
	DB 11111110B
	DB 10111111B
	DB 11101111B
	DB 11111011B
	DB 01111111B
	DB 11110111B
	DB 11111101B
	DB 11011111B
	DB 11111011B
	DB 10111111B
	DB 11101111B
	DB 11111110B
	DB 01111111B
	DB 10111111B
	DB 11110111B
	DB 11111101B
	DB 11011111B
	DB 11111011B
	DB 01111111B
	DB 11101111B
	DB 11111110B
	DB 11110111B
	DB 10111111B
TAB6:	DB 00011111B
	DB 11111111B
	DB 00011111B
	DB 11111111B

	DB 00000111B
	DB 11111111B
	DB 00000111B
	DB 11111111B
	
	DB 00000001B
	DB 11111111B
	DB 00000001B
	DB 11111111B

	DB 00000000B
	DB 11111111B
	DB 00000000B
	DB 11111111B

	DB 00000001B
	DB 11111111B
	DB 00000001B
	DB 11111111B

	DB 00000111B
	DB 11111111B
	DB 00000111B
	DB 11111111B

	DB 00011111B
	DB 11111111B
	DB 00011111B
	DB 11111111B

	
	DB 11111111B
	DB 11111111B

	

	DB 10111101B
	DB 11111111B
	DB 10111101B
	DB 11111111B

	DB 10011001B
	DB 11111111B
	DB 10011001B
	DB 11111111B
	
	DB 10000001B
	DB 11111111B
	DB 10000001B
	DB 11111111B

	DB 00000000B
	DB 11111111B
	DB 00000000B
	DB 11111111B

	DB 10000001B
	DB 11111111B
	DB 10000001B
	DB 11111111B

	DB 10011001B
	DB 11111111B
	DB 10011001B
	DB 11111111B

	DB 10111101B
	DB 11111111B
	DB 10111101B
	DB 11111111B

	DB 11111111B
	DB 11111111B

TAB7:	DB 11111110B	
	DB 11111000B
	DB 11100000B
	DB 01100000B
	DB 00000000B
	DB 01100000B	
	DB 11100000B
	DB 11111000B
	DB 11111110B
	DB 11111111B
	DB 10111111B
	DB 10101011B
	DB 00101010B
	DB 00100000B
	DB 00000000B
	DB 00100000B
	DB 00101010B
	DB 10101011B
	DB 10111111B
	DB 11111111B

TAB8:	DB 00000000B	
	DB 11111111B
	DB 00000000B	
	DB 11111111B
	DB 00000000B	
	DB 11111111B
	DB 00000000B	
	DB 11111111B

TAB9:	DB 11111110B	
	DB 11111010B
	DB 11111000B
	DB 11101000B
	DB 11100000B
	DB 01100000B	
	DB 00100000B
	DB 00000000B
	DB 00100000B
	DB 01100000B	
	DB 11100000B
	DB 11101000B
	DB 11111000B
	DB 11111010B
	DB 11111110B
	DB 11111111B

	END